diff --git a/src/Wt/WWebSocketConnection.C b/src/Wt/WWebSocketConnection.C
index ea2b9051..5450f2c3 100644
--- a/src/Wt/WWebSocketConnection.C
+++ b/src/Wt/WWebSocketConnection.C
@@ -453,7 +453,7 @@ bool WebSocketConnection::doAsyncWrite(OpCode type, const std::vector<char>& fra
   writeBuffer_.append(data.data(), data.size());
 
   // Put data into asio::buffer actual write buffer
-  using namespace boost::asio;
+  using namespace AsioWrapper::asio;
 
   std::vector<const_buffer> buffer;
   writeBuffer_.asioBuffers(buffer);
@@ -481,7 +481,7 @@ void WebSocketConnection::doControlFrameWrite(const std::vector<char>& frameHead
   // Put data into asio::buffer actual write buffer
   writeBuffer_.append(frameHeader.data(), frameHeader.size());
 
-  using namespace boost::asio;
+  using namespace AsioWrapper::asio;
 
   std::vector<const_buffer> buffer;
   writeBuffer_.asioBuffers(buffer);
@@ -602,12 +602,12 @@ void WebSocketTcpConnection::doClose()
 
 void WebSocketTcpConnection::doSocketRead(char* buffer, size_t size)
 {
-  using namespace boost::asio;
+  using namespace AsioWrapper::asio;
 
-  socket_->async_read_some(boost::asio::buffer(buffer, size), strand_.wrap(std::bind(&WebSocketTcpConnection::handleAsyncRead, shared_from_this(), std::placeholders::_1, std::placeholders::_2)));
+  socket_->async_read_some(AsioWrapper::asio::buffer(buffer, size), strand_.wrap(std::bind(&WebSocketTcpConnection::handleAsyncRead, shared_from_this(), std::placeholders::_1, std::placeholders::_2)));
 }
 
-void WebSocketTcpConnection::doSocketWrite(const std::vector<boost::asio::const_buffer>& buffer, OpCode type)
+void WebSocketTcpConnection::doSocketWrite(const std::vector<AsioWrapper::asio::const_buffer>& buffer, OpCode type)
 {
   async_write(socket(), buffer, strand_.wrap(std::bind(&WebSocketTcpConnection::handleAsyncWritten, shared_from_this(), type, std::placeholders::_1, std::placeholders::_2)));
 }
@@ -660,12 +660,12 @@ void WebSocketSslConnection::stopTcpSocket(const AsioWrapper::error_code& e)
 
 void WebSocketSslConnection::doSocketRead(char* buffer, size_t size)
 {
-  using namespace boost::asio;
+  using namespace AsioWrapper::asio;
 
-  socket_->async_read_some(boost::asio::buffer(buffer, size), strand_.wrap(std::bind(&WebSocketSslConnection::handleAsyncRead, shared_from_this(), std::placeholders::_1, std::placeholders::_2)));
+  socket_->async_read_some(AsioWrapper::asio::buffer(buffer, size), strand_.wrap(std::bind(&WebSocketSslConnection::handleAsyncRead, shared_from_this(), std::placeholders::_1, std::placeholders::_2)));
 }
 
-void WebSocketSslConnection::doSocketWrite(const std::vector<boost::asio::const_buffer>& buffer, OpCode type)
+void WebSocketSslConnection::doSocketWrite(const std::vector<AsioWrapper::asio::const_buffer>& buffer, OpCode type)
 {
   async_write(*socket_, buffer, strand_.wrap(std::bind(&WebSocketSslConnection::handleAsyncWritten, shared_from_this(), type, std::placeholders::_1, std::placeholders::_2)));
 }
diff --git a/src/Wt/WWebSocketConnection.h b/src/Wt/WWebSocketConnection.h
index da34e1b1..ca441cdc 100644
--- a/src/Wt/WWebSocketConnection.h
+++ b/src/Wt/WWebSocketConnection.h
@@ -132,7 +132,7 @@ protected:
 
   virtual void doSocketRead(char* buffer, size_t size) = 0;
   // Performs an async write to the socket, inside the write-done loop.
-  virtual void doSocketWrite(const std::vector<boost::asio::const_buffer>& buffer, OpCode type) = 0;
+  virtual void doSocketWrite(const std::vector<AsioWrapper::asio::const_buffer>& buffer, OpCode type) = 0;
 
 private:
   // Buffer & parsing
@@ -174,9 +174,9 @@ private:
   bool hasPendingPingWrite_;
   bool hasPendingPongWrite_;
   OpCode pendingWriteDataType_;
-  std::vector<boost::asio::const_buffer> pendingWritePingBuffer_;
-  std::vector<boost::asio::const_buffer> pendingWritePongBuffer_;
-  std::vector<boost::asio::const_buffer> pendingWriteDataBuffer_;
+  std::vector<AsioWrapper::asio::const_buffer> pendingWritePingBuffer_;
+  std::vector<AsioWrapper::asio::const_buffer> pendingWritePongBuffer_;
+  std::vector<AsioWrapper::asio::const_buffer> pendingWriteDataBuffer_;
 
   std::function<void()> hasDataReadCallback_;
   std::function<void(const AsioWrapper::error_code&, std::size_t)> hasDataWrittenCallback_;
@@ -199,7 +199,7 @@ public:
 
 protected:
   void doSocketRead(char* input, size_t offset) final;
-  void doSocketWrite(const std::vector<boost::asio::const_buffer>& buffer, OpCode type) final;
+  void doSocketWrite(const std::vector<AsioWrapper::asio::const_buffer>& buffer, OpCode type) final;
 
 private:
   std::unique_ptr<Socket> socket_;
@@ -219,7 +219,7 @@ public:
 
 protected:
   void doSocketRead(char* input, size_t offset) final;
-  void doSocketWrite(const std::vector<boost::asio::const_buffer>& buffer, OpCode type) final;
+  void doSocketWrite(const std::vector<AsioWrapper::asio::const_buffer>& buffer, OpCode type) final;
 
 private:
   std::unique_ptr<SSLSocket> socket_;